{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.evenBetterToml = {
          enable = lib.mkEnableOption "should the even-better-toml extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "even-better-toml" {
            default = ["tamasfe" "even-better-toml"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.evenBetterToml.enable {
        extensions = [
          config.extraExtensions.evenBetterToml.extension
        ];
      };
    }));
  };
}
