{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.go = {
          enable = lib.mkEnableOption "should the go extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "go" {
            default = ["golang" "go"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.go.enable {
        extensions = [
          config.extraExtensions.go.extension
        ];
      };
    }));
  };
}
