{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.vscode-marketplace;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.nearley = {
          enable = lib.mkEnableOption "should the nearley extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "nearley" {
            default = ["karyfoundation" "nearley"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.nearley.enable {
        extensions = [
          config.extraExtensions.nearley.extension
        ];
      };
    }));
  };
}
