{
  lib,
  pkgs,
  config,
  ...
}: let
  pkgsRepositories = pkgs.nix-vscode-extensions.forVSCodeVersion config.programs.vscode.package.version;
  pkgsRepository = pkgsRepositories.open-vsx;
in {
  options.programs.vscode.profiles = lib.mkOption {
    type = lib.types.attrsOf (lib.types.submodule ({config, ...}: {
      options = {
        extraExtensions.openRemoteSsh = {
          enable = lib.mkEnableOption "should the open-remote-ssh extension for vscode be enabled";
          extension = lib.mkPackageOption pkgsRepository "open-remote-ssh" {
            default = ["jeanp413" "open-remote-ssh"];
          };
        };
      };
      config = lib.mkIf config.extraExtensions.openRemoteSsh.enable {
        extensions = [
          config.extraExtensions.openRemoteSsh.extension
        ];
      };
    }));
  };
}
